/*
 * Goldwater Distributed Web Architecture.
 * - Goldwater Version
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *
 * $Revision: 1.6 $  $Date: 2003/06/14 11:57:17 $
 * 
 * --------------------------------------------------------------------------
 * $Log: gw_version.c,v $
 * Revision 1.6  2003/06/14 11:57:17  csmith
 * Changed escaping of version message
 *
 * Revision 1.5  2003/06/12 11:55:53  csmith
 * Put FSF copyright first.
 *
 * Revision 1.4  2003/05/29 22:38:23  csmith
 * Added FSF copyright
 *
 * Revision 1.3  2003/04/13 12:16:38  csmith
 * Added build target to version information
 *
 * Revision 1.2  2003/03/29 12:21:10  csmith
 * cvs merge to 0.3.4
 *
 * Revision 1.6  2003/01/02 20:25:30  chris
 * Allows configuration of IPC SHM umask (default is 066)
 *
 * Revision 1.5  2002/11/30 14:04:42  chris
 * GPL headers
 *
 * Revision 1.4  2002/08/26 19:09:17  chris
 * Display domain bridge version in admin 'version' command
 *
 * Revision 1.3  2002/05/12 23:00:14  chris
 * When the administrator cannot be started due to Goldwater IPC being
 * unavailable or unstable - log a message at a WARNING or SERIOUS level.
 * Also return the new error GWE_UNSTABLE if the IPC is unstable.
 *
 * Revision 1.2  2002/03/11 22:34:30  chris
 * More uptodate TODO and other things.
 *
 * Revision 1.1  2002/03/10 15:30:39  chris
 * New support
 *
 * --------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <phlib/xl_types.h>
#include <phlib/xl_string.h>

#include "gwadmin.h"
#include "version.h"             /* Admin version */
#include "../guardian/version.h" /* Goldwater Version */
#include "../dombridge/version.h"/* DomBridge Version */
#include "../asyncmgr/version.h" /* Async Manager Version */

/* ------------------------------------------------------------------------- */

RetValue
gw_version( CString *argCS )
{
  printf( "\
\n\
Goldwater Version "VERSION" - "BUILDTARGET"\n\
Goldwater Domain Bridge Version "DOM_VERSION"\n\
Goldwater Async Manager Version "ASM_VERSION"\n\
Goldwater Administrator Version "ADMIN_VERSION"\n\
Copyright (C) 2003 Free Software Foundation, Inc..\n\
Copyright (C) 1997-2003 netFluid Technology Ltd.\n\
\n\
This software comes with ABSOLUTELY NO WARRANTY. This is free software,\n\
and you are welcome to modify and redistribute it under the GPL licence.\n\
\n\
Goldwater is maintained by netFluid Technology Ltd. and other GNU volunteers\n\
http://www.gnu.org/software/goldwater\n\
http://www.nfluid.co.uk\n\
\n\
" );

  return Success;
}

/* ------------------------------------------------------------------------- */
/* end */
