#ifndef _DBRIDGE_H
#define _DBRIDGE_H
/*
 * Domain Bridge
 *
 * Copyright 2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * --------------------------------------------------------------------------
 * $Id: dbridge.h,v 1.2 2003/03/29 12:21:10 csmith Exp $
 * --------------------------------------------------------------------------
 */

#include <phlib/xl_types.h>
#include <phlib/xl_linklst.h>

#include "gwreq.h"


typedef struct {
 GWMsgCtrl rctrl;
 time_t    q_time;     /* Time domain bridge received message */
 uuid_t    txid;       /* Transaction ID                      */
 GWMsgFlags ret_error_on_cleanup; 
} DomainMessage;

typedef struct {
  long   domainid;      /* ID of BB domain entry     */
  int    session_id;    /* Session ID of connection  */
  long   conkey;        /* Connection key - for connection integrity check */
  LIST  *message_chain; /* Chain of pending messages (DomainMessage)       */
  LIST  *dead_message_chain; /* Chain of Dead messages (DomainMessage)     */
} DomainNode;

extern const char SERVICE[];

RetValue connect_domain( int domid );

#endif
