/*
 * Goldwater Distributed Web Architecture.
 *
 * Common Domain Handling
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.2 $  $Date: 2003/03/29 12:21:11 $
 * --------------------------------------------------------------------------
 * $Log: gwdomain.h,v $
 * Revision 1.2  2003/03/29 12:21:11  csmith
 * cvs merge to 0.3.4
 *
 * Revision 1.5  2003/01/04 13:24:40  chris
 * Moved __gw_find_domain_idx_in_config from gwdomain to gwreadconf
 * as it is used in quite a few places outside libgwdom
 *
 * Revision 1.4  2002/08/22 19:08:34  chris
 * Added __gw_domain_id
 *
 * Revision 1.3  2002/06/10 17:34:47  chris
 * All phlib includes have phlib/ prefix and gwlib includes have nothing.
 *
 * Revision 1.2  2002/05/26 17:52:20  chris
 * Pulled code that searches config for domain entry given a name into a new
 * function so that it can be called externally.
 *
 * Revision 1.1  2002/05/21 21:16:09  chris
 * Common Domain Handling functionality.
 *
 * --------------------------------------------------------------------------
 */
#ifndef _GW_DOMAIN_H
#define _GW_DOMAIN_H

#include <phlib/xl_types.h>
#include <phlib/xl_string.h>
#include <phlib/xl_memlst.h>

#include <goldreq.h>

/* ------------------------------------------------------------------------- */

typedef enum { 
  GWD_UNAVAILABLE = 0, 
  GWD_AVAILABLE   = 1, 
  GWD_OFFLINE     = 2
} DomAvail;

RetValue  __gw_remove_domain_enry( const char *  );
int       __gw_get_domain_id( const char *domain );
BBDom    *__gw_domain_from_config( const char *domain );
BBDom    *__gw_add_domain_entry  ( const char *, const char *, const char *, int );
DomAvail   __gw_domain_set_state( const char *domain, DomAvail state );

/* ------------------------------------------------------------------------- */
/* end */

#endif
