/*
 * Goldwater Distributed Web Architecture.
 *
 * Global parameters
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * $Revision: 1.2 $  $Date: 2003/03/29 12:21:11 $
 * 
 * --------------------------------------------------------------------------
 * $Log: gwgbprm.h,v $
 * Revision 1.2  2003/03/29 12:21:11  csmith
 * cvs merge to 0.3.4
 *
 * Revision 1.13  2003/01/04 19:34:11  chris
 * gw_init() is now quite intelligent with respect to reconnecting.
 *
 * Revision 1.12  2003/01/03 00:09:11  chris
 * Use internal umask when creating files, shm and queues
 *
 * Revision 1.11  2002/10/20 13:38:34  chris
 * Enabled setting of loglevel from administrator (removed _LogLevel and
 * replaced it with *_LogLevelPtr through out code).
 *
 * Revision 1.10  2002/06/16 11:40:35  chris
 * BB Client is now the Domain Bridge message tracking list.
 * New error codes and messages.
 *
 * Revision 1.9  2002/06/10 17:34:47  chris
 * All phlib includes have phlib/ prefix and gwlib includes have nothing.
 *
 * Revision 1.8  2002/05/30 19:37:34  chris
 * Create entries in BBClient table for each new client attaching to
 * application.
 *
 * Revision 1.7  2002/05/12 17:46:16  chris
 * Store msgid of expected reply in SHM so that Domain Bridge can validate
 * the reply at it's door ..
 *
 * Revision 1.6  2002/05/12 14:03:13  chris
 * GPL licence headers etc
 *
 * Revision 1.5  2002/02/24 18:05:38  chris
 * Moved APPDIR to BBControl block instead of duplicating it for each and
 * every server.
 * Return GWE_APPERR and set gwusrerr when Services return failure.
 * Use new regstrings that describe the new XML based configuration.
 * Added new functions to support individual addition of service entries.
 * New Version 1.14
 *
 * Revision 1.4  2001/12/26 22:57:43  chris
 * Changed all references to Imagepage Computing to netFluid Technology.
 *
 * Revision 1.3  2001/06/30 16:40:55  chris
 * Added __gw_populate_globals_from_shm
 *
 * Revision 1.2  2001/04/01 22:46:45  chris
 * Added _MyServEntry and _ReplyQueue.  Removed _LrgFlThrsh.
 *
 * Revision 1.1  2001/03/19 16:05:06  chris
 * Initial revision
 *
 * --------------------------------------------------------------------------
 */
#ifndef _GW_GLOBAL_PARAM_H
#define _GW_GLOBAL_PARAM_H

#include <phlib/xl_memlst.h>
#include <goldreq.h>
#include <sys/types.h>
#include <sys/stat.h>

extern int   _gw_initialised;

extern long  _ServClass;
extern long  _ServId;

extern long  _IpcKey;
extern long *_LogLevelPtr;
extern long  _MaxMsgTx;
extern long  _GWPort;
extern long  _ReqTout;

extern mode_t  _Mask;

extern char *_Mode;
extern char *_GWHost;
extern char *_SpoolDir;
extern char *_LogName;
extern char *_Domain;

extern int        _ReplyQueue;    /* Only Used By Servers */
extern BBEntry   *_MyServEntry;   /* Only Used By Servers */
#if 0
extern BBClient  *_MyClientEntry; /* Only used by Vanilla Clients */
#endif


extern SHMLIST   *_ServiceList;
extern SHMLIST   *_ServerList;
extern BBControl *bbc;

int  __gw_set_global_params();
void __gw_reset_global_params();
void __gw_populate_globals_from_shm();

#endif
