/*
 * Goldwater Distributed Web Architecture.
 *
 * Message Processing API
 *
 * Copyright 1996-2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * $Revision: 1.2 $  $Date: 2003/03/29 12:21:11 $
 * 
 * --------------------------------------------------------------------------
 * $Log: gwmsg.h,v $
 * Revision 1.2  2003/03/29 12:21:11  csmith
 * cvs merge to 0.3.4
 *
 * Revision 1.8  2002/06/16 00:18:31  chris
 * Use gwuuid_compare to compare uuid_t buffers (4 32bit ints) because it is
 * faster.
 *
 * Revision 1.7  2002/06/11 21:52:58  chris
 * Enabled timed blocking in gwp_get_request and use this in dbridge to
 * prevent spinning and chewing cpu time.
 *
 * Revision 1.6  2002/06/10 17:34:47  chris
 * All phlib includes have phlib/ prefix and gwlib includes have nothing.
 *
 * Revision 1.5  2002/05/12 14:03:13  chris
 * GPL licence headers etc
 *
 * Revision 1.4  2002/03/10 19:35:33  chris
 * Handles proper homed messages (initially for shutdown of servers).
 *
 * Revision 1.3  2002/01/29 22:43:40  chris
 * Cleaned up warnings.
 * Added gwp_ prefix to shutdown_server.
 * Added regdata.[ch] config entry to build.
 *
 * Revision 1.2  2001/12/26 22:57:43  chris
 * Changed all references to Imagepage Computing to netFluid Technology.
 *
 * Revision 1.1  2001/03/19 16:05:56  chris
 * Initial revision
 *
 * --------------------------------------------------------------------------
 */
#ifndef GW_MSG_H
#define GW_MSG_H

#include <phlib/xl_types.h>
#include <phlib/xl_string.h>

#include <gwreq.h>


RetValue gwp_write_block_init ( GWMsgCtrl *ctrl );
RetValue gwp_write_block_data ( GWMsgCtrl *ctrl, const char *data, long dsize);
RetValue gwp_write_block_flush( GWMsgCtrl *ctrl );


RetValue gwp_get_reply        ( GWMsgCtrl *ctrl );
RetValue gwp_cleanup_ctrl     ( GWMsgCtrl *ctrl );
RetValue gwp_finish_request   ( GWMsgCtrl *ctrl );

unsigned char *gwp_get_request( GWMsgCtrl *ctrl, long mtype );

void     gwp_remove_reply_queue();
RetValue gwp_cleanup_ctrl     ( GWMsgCtrl *ctrl );

void     gwp_shutdown_server  ( );

int gwuuid_compare( uuid_t u1, uuid_t u2 );
#endif
