#ifndef GWNS_CTRL_H
#define GWNS_CTRL_H
/*
 * Domain NetServer Control Header
 *
 * Copyright 2002 netFluid Technology Ltd
 *
 * Goldwater is written and maintained by netFluid Technology Ltd.
 * http://www.nfluid.co.uk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 * --------------------------------------------------------------------------
 * $Id: nsctrl.h,v 1.2 2003/03/29 12:21:11 csmith Exp $
 * --------------------------------------------------------------------------
 */

#include <gwreq.h>
#include "../dombridge/dbcom.h"

typedef enum{ Message = 1, ReadAuthInfo, Data, RecACK } DataPhase;

typedef struct {
  GWStatus result;
  int      error;
} DMsgStatus;

typedef struct {
  char      buf[256];
  DataPhase phase;
  CString   auth_dataCS;
  int       auth_len;
  GDMB_AuthMode auth_type;
  int       reqtout;
  char      service[ SVC_NM_MAX ];
  char      fromdom[ DOM_NM_MAX ];
  int       fromdom_id;
  uuid_t    txid;
  BBSvc     svc_info;
  GWMsgCtrl ctrl;
  long      dlen;
  MsgBlock  req_msgf;
  DMsgStatus status;
} nsSession;

typedef enum {
  EU_MY_SESSION_QUIT = 256,
  EU_NEW_MESSAGE,
  EU_MSG_PENDING,
  EU_REQ_TIMEOUT,
  EU_REQMSGSND_EAGAIN,
  EU_REPMSGSND_EAGAIN,
  
  EUT_ACK_TIMEOUT
} GWNS_UserEvents;

RetValue init_ns_network();
void     send_ack( nsSession *sc, GWStatus stat, int err );

#endif
